//// 
//// Autogenerated by xlw 
//// Do not edit this file, it will be overwritten 
//// by InterfaceGenerator 
////

#include <xlw/MyContainers.h>
#include <xlw/CellMatrix.h>
#include "DLL.h"
#include <xlw/xlw.h>
#include <xlw/XlFunctionRegistration.h>
#include <stdexcept>
#include <xlw/XlOpenClose.h>
#include <ctime>
namespace {
const char* LibraryName = "Scilab_XLL";
};

// dummy function to force linkage
namespace {
void DummyFunction()
{
xlAutoOpen();
xlAutoClose();
}
}

// registrations start here


namespace
{
XLRegistration::Arg
SLEvalStringArgs[]=
{
{ "command"," command to send to Scilab ","XLW_WSTR"}
};
  XLRegistration::XLFunctionRegistrationHelper
registerSLEvalString("xlSLEvalString",
"SLEvalString",
"Evaluate command in Scilab software ",
LibraryName,
SLEvalStringArgs,
1
,false
);
}



extern "C"
{
LPXLFOPER EXCEL_EXPORT
xlSLEvalString(
XLWSTR commanda)
{
EXCEL_BEGIN;

	if (XlfExcel::Instance().IsCalledByFuncWiz())
		return XlfOper(true);

std::wstring command(
	voidToWstr(commanda));

double result(
	SLEvalString(
		command)
	);
return XlfOper(result);
EXCEL_END
}
}



//////////////////////////

namespace
{
XLRegistration::Arg
SLPutMatrixArgs[]=
{
{ "variable_name"," variable name ","XLW_WSTR"},
{ "matrixvalues"," data ","XLF_OPER"}
};
  XLRegistration::XLFunctionRegistrationHelper
registerSLPutMatrix("xlSLPutMatrix",
"SLPutMatrix",
"Create or overwrite Scilab matrix with data from Microsoft Excel worksheet ",
LibraryName,
SLPutMatrixArgs,
2
,false
);
}



extern "C"
{
LPXLFOPER EXCEL_EXPORT
xlSLPutMatrix(
XLWSTR variable_namea,
LPXLFOPER matrixvaluesa)
{
EXCEL_BEGIN;

	if (XlfExcel::Instance().IsCalledByFuncWiz())
		return XlfOper(true);

std::wstring variable_name(
	voidToWstr(variable_namea));

XlfOper matrixvaluesb(
	(matrixvaluesa));
CellMatrix matrixvalues(
	matrixvaluesb.AsCellMatrix("matrixvalues"));

double result(
	SLPutMatrix(
		variable_name,
		matrixvalues)
	);
return XlfOper(result);
EXCEL_END
}
}



//////////////////////////

namespace
{
XLRegistration::Arg
SLGetMatrixArgs[]=
{
{ "variable_name"," variable name ","XLW_WSTR"}
};
  XLRegistration::XLFunctionRegistrationHelper
registerSLGetMatrix("xlSLGetMatrix",
"SLGetMatrix",
"Write contents of Scilab matrix to Microsoft Excel worksheet ",
LibraryName,
SLGetMatrixArgs,
1
,false
);
}



extern "C"
{
LPXLFOPER EXCEL_EXPORT
xlSLGetMatrix(
XLWSTR variable_namea)
{
EXCEL_BEGIN;

	if (XlfExcel::Instance().IsCalledByFuncWiz())
		return XlfOper(true);

std::wstring variable_name(
	voidToWstr(variable_namea));

CellMatrix result(
	SLGetMatrix(
		variable_name)
	);
return XlfOper(result);
EXCEL_END
}
}



//////////////////////////

